#include <stdio.h>

long long int num[4]= {0};
long long int multiply[4]= {256*256*256, 256*256, 256, 1};

int main() {
	char buf;
	int n= 0;
	scanf("%d", &n);
	for(int i=0 ; i<n ; i++) {
		for(int j=0 ; j<3 ; j++) 
			scanf("%d%c", &num[j], &buf);
		scanf("%d", &num[3]);
		
		long long sum = 0;
		for(int j=0 ; j<4 ; j++) {
			sum += num[j] * multiply[j];
			//printf("%lld\n", num[j] *multiply[j]);
		}
		printf("%lld ",sum);
		
		int x = num[0];
		if( x == 0 || x > 223 ) 
			printf("other");
		else if ( x < 127 ) 
			printf("A");
		else if ( x == 127 )
			printf("localhost");
		else if ( x < 192 ) 
			printf("B");
		else if ( x < 224 ) 
			printf("C");
		printf("\n");
		
	}
}

